## kim-api 2.0~beta2.gita734d1

=== CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


cmake_minimum_required(VERSION 3.4)
enable_testing()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)
list(APPEND CMAKE_PREFIX_PATH ${CMAKE_CURRENT_BINARY_DIR})

include(DefaultCompilerStandards)

# Define options
#
set(PROJECT_PREFIX "kim-api" CACHE STRING "Project prefix string")
mark_as_advanced(KIM_API_PROJECT_PREFIX)
#
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(LOG_MAX "DEBUG")
else()
  set(LOG_MAX "ERROR")
endif()
set(KIM_API_LOG_MAXIMUM_LEVEL "${LOG_MAX}" CACHE STRING "Maximum log verbosity")
set_property(CACHE KIM_API_LOG_MAXIMUM_LEVEL PROPERTY STRINGS SILENT FATAL ERROR WARNING INFORMATION DEBUG)
#
option(KIM_API_BUILD_MODELS_AND_DRIVERS "Build all included models, drivers, and simulators" OFF)
#
option(KIM_API_ENABLE_SANITIZE "Enable AddressSanitizer" OFF)
mark_as_advanced(KIM_API_ENABLE_SANITIZE)
#
option(KIM_API_ENABLE_COVERAGE "Enable code coverage" OFF)
mark_as_advanced(KIM_API_ENABLE_COVERAGE)
#
# option(KIM_API_DOWNLOAD_OPENKIM "TODO Download all models, model drivers and simulators" OFF)
#
# Additional options (that depend on call to project()) defined below


#
# Define main project
#
project(${PROJECT_PREFIX}-v2 VERSION 2.0.0 LANGUAGES CXX C Fortran)
include(GNUInstallDirs)  # needs to come after call to project()
include(DefaultRPATHSettings)
include(DefineVersionVariables)


# Define options dependent on PROJECT_NAME
#
set(KIM_API_USER_CONFIGURATION_FILE ".${PROJECT_NAME}/config" CACHE STRING "Default configuration file name.  If not absolute, then relative to user home directory")
mark_as_advanced(KIM_API_USER_CONFIGURATION_FILE)

include(DefineInternalVariables)

include(DefaultCompilerFlags)

# Define kim-api target
#
add_library(kim-api SHARED "")
set_target_properties(kim-api
  PROPERTIES
    OUTPUT_NAME "${PROJECT_NAME}"
    INSTALL_NAME_DIR "${CMAKE_INSTALL_FULL_LIBDIR}"
    SOVERSION ${PROJECT_VERSION_MAJOR}
    Fortran_MODULE_DIRECTORY "${CMAKE_BINARY_DIR}/Fortran_MODULES"
    )
target_include_directories(kim-api PUBLIC $<TARGET_PROPERTY:kim-api,Fortran_MODULE_DIRECTORY>)
target_include_directories(kim-api PUBLIC ${CMAKE_BINARY_DIR})
target_link_libraries(kim-api ${CMAKE_DL_LIBS})

# Add include subdirectories
#
add_subdirectory(cpp/include)
add_subdirectory(c/include)
add_subdirectory(fortran/src)

# Add src subdirectories
#
add_subdirectory(cpp/src)
add_subdirectory(c/src)
add_subdirectory(fortran/include)

# Add other subdirectories
#
add_subdirectory(cmake)
add_subdirectory(completions)
add_subdirectory(pkg-config)
add_subdirectory(utils)

if(${CMAKE_MINOR_VERSION} GREATER 8)
  add_subdirectory(docs)
endif()


# Add Models & Drivers, if appropriate
#
if(KIM_API_BUILD_MODELS_AND_DRIVERS)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_BINARY_DIR}/cmake/Modules)
  add_subdirectory(examples/models)
  add_subdirectory(examples/model-drivers)
  add_subdirectory(examples/simulators)
endif()


# # Add downloads, if appropriate
# #
# if(KIM_API_DOWNLOAD_OPENKIM)
#     # TODO insert full model/model_driver/simulator git repo or tarball here
#     set(GIT_REPOSITORY "https://github.com/openkim/kim-api.git")
#     set(GIT_BRANCH "cmake")
#
#     # TODO don't hardcode the directory "download"
#     if(EXISTS ${CMAKE_BINARY_DIR}/download)
#         execute_process(COMMAND git pull  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/download)
#     else()
#         execute_process(COMMAND git clone -b ${GIT_BRANCH} ${GIT_REPOSITORY} download WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
#     endif()
#
#     # TODO don't hardcode these directories
#     add_subdirectory(${CMAKE_BINARY_DIR}/download/examples/models)
#     add_subdirectory(${CMAKE_BINARY_DIR}/download/examples/model-drivers)
#     add_subdirectory(${CMAKE_BINARY_DIR}/download/examples/simulators)
# endif()


# Add install rules for kim-api
#
install(TARGETS kim-api DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== cmake/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


set(CONFIG_FILE_IN config.cmake.in)
set(CONFIG_FILE ${PROJECT_NAME}-config.cmake)
set(CONFIG_VERSION_FILE_IN config-version.cmake.in)
set(CONFIG_VERSION_FILE ${PROJECT_NAME}-config-version.cmake)

configure_file("${CONFIG_FILE_IN}" "${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_FILE}" @ONLY)
configure_file("${CONFIG_VERSION_FILE_IN}"
  "${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_VERSION_FILE}" @ONLY)

install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_FILE}"
  "${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_VERSION_FILE}"
  DESTINATION
  ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/${KIM_API_CMAKE_DIR_IDENTIFIER}
  )

set(WRAPPER_SOURCES
  model-driver-wrapper.cpp.in
  parameterized-model-wrapper.cpp.in
  simulator-model-wrapper.cpp.in
  stand-alone-model-wrapper.cpp.in
  )

set(INFORMATION_FILES
  model-driver-info.txt.in
  parameterized-model-info.txt.in
  simulator-model-info.txt.in
  stand-alone-model-info.txt.in
  )

install(
  FILES ${WRAPPER_SOURCES} ${INFORMATION_FILES}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/${KIM_API_CMAKE_DIR_IDENTIFIER}
  )

add_subdirectory(Modules)

=== completions/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


set(BASH_COMPLETIONS ${PROJECT_NAME}-completion.bash)

string(MAKE_C_IDENTIFIER "${PROJECT_NAME}" KIM_API_C_ID_PROJECT_NAME)

configure_file(completion.bash.in ${BASH_COMPLETIONS} @ONLY)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${BASH_COMPLETIONS}
  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/${KIM_API_BASH_COMPLETION_DIR_IDENTIFIER}
  )

=== docs/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#

cmake_minimum_required(VERSION 3.9)

cmake_policy(SET CMP0057 NEW)
cmake_policy(SET CMP0054 NEW)

find_package(Doxygen)

set(DOXYGEN_PROJECT_NAME         "${PROJECT_NAME}")
set(DOXYGEN_STRIP_FROM_PATH      "../../")
set(DOXYGEN_TAB_SIZE             2)
set(DOXYGEN_EXTRACT_ALL          YES)
set(DOXYGEN_EXTRACT_STATIC       YES)
set(DOXYGEN_EXTRACT_ANON_NSPACES YES)
set(DOXYGEN_FILE_PATTERNS
  "*.c" "*.cc" "*.cxx" "*.cpp" "*.c++" "*.java" "*.ii" "*.ixx" "*.ipp"
  "*.i++" "*.inl" "*.idl" "*.ddl" "*.odl" "*.h" "*.hh" "*.hxx" "*.hpp" "*.h++"
  "*.cs" "*.d" "*.php" "*.php4" "*.php5" "*.phtml" "*.inc" "*.m" "*.markdown"
  "*.md" "*.mm" "*.dox" "*.py" "*.pyw" "*.f90" "*.f95" "*.f03" "*.f08" "*.f"
  "*.for" "*.tcl" "*.vhd" "*.vhdl" "*.ucf" "*.qsf" "Makefile" "CMakeLists.txt"
  "*.inc" "*.tpl" "*.sh" "*.fd" "*.params" "README"
)


set(DOXYGEN_RECURSIVE            YES)
set(DOXYGEN_EXAMPLE_PATH         "src/porting-scripts")
set(DOXYGEN_IMAGE_PATH           "src/asymptote-figures")
set(DOXYGEN_SOURCE_BROWSER       YES)
set(DOXYGEN_USE_MATHJAX          YES)
set(DOXYGEN_MATHJAX_RELPATH      "https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.3")
set(DOXYGEN_EXTRA_PACKAGES       "amsmath")
set(DOXYGEN_GENERATE_LATEX       YES)

set(SOURCES
  "src/introduction.txt"
  "src/features.txt"
  "src/theory.txt"
  "src/implementation.txt"
  "src/version2-differences.txt"
  "src/porting-content-from-v1-to-v2.txt"
  "porting-content-from-v1-to-v2-examples/"
  "../cpp/include/"
  "../c/include/"
  "../fortran/include/"
  "../examples/model-drivers/"
  "../examples/models/"
  "../examples/simulators/"
  )

if(DOXYGEN_FOUND)
  doxygen_add_docs(
    docs
    ${SOURCES}
    COMMENT "Generate documentation"
    )

  add_custom_command(OUTPUT refman.pdf
    COMMAND make
    COMMAND ${CMAKE_COMMAND} -E copy refman.pdf ${CMAKE_CURRENT_BINARY_DIR}/refman.pdf
    WORKING_DIRECTORY latex
    DEPENDS docs
    )

  # TODO fix dependencies
  add_custom_target(pdf DEPENDS docs refman.pdf SOURCES ${SOURCES})
endif(DOXYGEN_FOUND)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION ${CMAKE_INSTALL_DOCDIR} OPTIONAL)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/refman.pdf DESTINATION ${CMAKE_INSTALL_DOCDIR} OPTIONAL)

=== pkg-config/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


set(PKG_CONFIG_FILE "${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME}.pc")

configure_file(libkim-api.pc.in ${PKG_CONFIG_FILE} @ONLY)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${PKG_CONFIG_FILE}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/${KIM_API_PKG_CONFIG_DIR_IDENTIFIER}
  )

=== utils/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


set(SIMULATOR_MODEL        ${PROJECT_NAME}-simulator-model)
set(COLLECTIONS_INFO       ${PROJECT_NAME}-collections-info)
set(COLLECTIONS_MANAGEMENT ${PROJECT_NAME}-collections-management)
set(ACTIVATE_SCRIPT        ${PROJECT_NAME}-activate)
set(DEACTIVATE_SCRIPT      ${PROJECT_NAME}-deactivate)

configure_file(collections-management.in ${COLLECTIONS_MANAGEMENT} @ONLY)
configure_file(activate.in ${ACTIVATE_SCRIPT} @ONLY)
configure_file(deactivate.in ${DEACTIVATE_SCRIPT} @ONLY)

add_executable(simulator-model simulator-model.cpp)
target_link_libraries(simulator-model kim-loader)
set_target_properties(simulator-model PROPERTIES OUTPUT_NAME ${SIMULATOR_MODEL})

add_executable(collections-info collections-info.cpp)
target_link_libraries(collections-info kim-loader)
set_target_properties(collections-info PROPERTIES OUTPUT_NAME ${COLLECTIONS_INFO})

install(
  TARGETS simulator-model collections-info
  DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/${PROJECT_NAME}
  )

install(
  PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${ACTIVATE_SCRIPT}
           ${CMAKE_CURRENT_BINARY_DIR}/${COLLECTIONS_MANAGEMENT}
           ${CMAKE_CURRENT_BINARY_DIR}/${DEACTIVATE_SCRIPT}
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  )

=== c/include/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


target_include_directories(kim-api PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

configure_file(KIM_Version.h.in ${CMAKE_BINARY_DIR}/KIM_Version.h)

set(C_HEADERS
    KIM_ChargeUnit.h
    KIM_ComputeArgumentName.h
    KIM_ComputeArguments.h
    KIM_ComputeCallbackName.h
    KIM_DataType.h
    KIM_EnergyUnit.h
    KIM_func.h
    KIM_LanguageName.h
    KIM_LengthUnit.h
    KIM_Log.h
    KIM_LogVerbosity.h
    KIM_ModelComputeArgumentsCreate.h
    KIM_ModelComputeArgumentsCreateLogMacros.h
    KIM_ModelComputeArgumentsDestroy.h
    KIM_ModelComputeArgumentsDestroyLogMacros.h
    KIM_ModelComputeArguments.h
    KIM_ModelComputeArgumentsLogMacros.h
    KIM_ModelCompute.h
    KIM_ModelComputeLogMacros.h
    KIM_ModelCreate.h
    KIM_ModelCreateLogMacros.h
    KIM_ModelDestroy.h
    KIM_ModelDestroyLogMacros.h
    KIM_ModelDriverCreate.h
    KIM_ModelDriverCreateLogMacros.h
    KIM_ModelDriverHeaders.h
    KIM_ModelHeaders.h
    KIM_Model.h
    KIM_ModelRefresh.h
    KIM_ModelRefreshLogMacros.h
    KIM_Numbering.h
    KIM_SemVer.h
    KIM_SimulatorHeaders.h
    KIM_SpeciesName.h
    KIM_SupportStatus.h
    KIM_TemperatureUnit.h
    KIM_TimeUnit.h
    KIM_UnitSystem.h
    ${CMAKE_BINARY_DIR}/KIM_Version.h
    )

install(FILES ${C_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

=== c/src/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


set(C_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ChargeUnit_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArgumentName_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArguments_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeCallbackName_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_DataType_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_EnergyUnit_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LanguageName_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LengthUnit_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Log_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LogVerbosity_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Model_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelCompute_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArguments_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArgumentsCreate_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArgumentsDestroy_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelCreate_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelDestroy_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelDriverCreate_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelRefresh_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Numbering_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SemVer_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SpeciesName_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SupportStatus_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_TemperatureUnit_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_TimeUnit_c.cpp
  )

target_sources(kim-api PRIVATE ${C_SOURCES})

=== cmake/Modules/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


install(
  FILES FindKIM-API-V2.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/${KIM_API_CMAKE_DIR_IDENTIFIER}/Modules
  )

=== cpp/include/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


target_include_directories(kim-api PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

configure_file(KIM_LOG_DEFINES.inc.in ${CMAKE_BINARY_DIR}/KIM_LOG_DEFINES.inc)
configure_file(KIM_Version.hpp.in ${CMAKE_BINARY_DIR}/KIM_Version.hpp)

set(CPP_HEADERS
  KIM_ChargeUnit.hpp
  KIM_ChargeUnit.inc
  KIM_ComputeArgumentName.hpp
  KIM_ComputeArgumentName.inc
  KIM_ComputeArguments.hpp
  KIM_ComputeCallbackName.hpp
  KIM_ComputeCallbackName.inc
  KIM_DataType.hpp
  KIM_DataType.inc
  KIM_EnergyUnit.hpp
  KIM_EnergyUnit.inc
  KIM_func.hpp
  KIM_LanguageName.hpp
  KIM_LanguageName.inc
  KIM_LengthUnit.hpp
  KIM_LengthUnit.inc
  KIM_Log.hpp
  KIM_LogVerbosity.hpp
  KIM_ModelComputeArgumentsCreate.hpp
  KIM_ModelComputeArgumentsCreateLogMacros.hpp
  KIM_ModelComputeArgumentsDestroy.hpp
  KIM_ModelComputeArgumentsDestroyLogMacros.hpp
  KIM_ModelComputeArguments.hpp
  KIM_ModelComputeArgumentsLogMacros.hpp
  KIM_ModelCompute.hpp
  KIM_ModelComputeLogMacros.hpp
  KIM_ModelCreate.hpp
  KIM_ModelCreateLogMacros.hpp
  KIM_ModelDestroy.hpp
  KIM_ModelDestroyLogMacros.hpp
  KIM_ModelDriverCreate.hpp
  KIM_ModelDriverCreateLogMacros.hpp
  KIM_ModelDriverHeaders.hpp
  KIM_ModelHeaders.hpp
  KIM_Model.hpp
  KIM_ModelRefresh.hpp
  KIM_ModelRefreshLogMacros.hpp
  KIM_Numbering.hpp
  KIM_Numbering.inc
  KIM_SemVer.hpp
  KIM_SimulatorHeaders.hpp
  KIM_SpeciesName.hpp
  KIM_SpeciesName.inc
  KIM_SupportStatus.hpp
  KIM_SupportStatus.inc
  KIM_TemperatureUnit.hpp
  KIM_TemperatureUnit.inc
  KIM_TimeUnit.hpp
  KIM_TimeUnit.inc
  KIM_UnitSystem.hpp
  ${CMAKE_BINARY_DIR}/KIM_LOG_DEFINES.inc
  ${CMAKE_BINARY_DIR}/KIM_Version.hpp
  )

install(FILES ${CPP_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

=== cpp/src/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


target_include_directories(kim-api PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

configure_file(KIM_Configuration.hpp.in ${CMAKE_BINARY_DIR}/KIM_Configuration.hpp)

set(CPP_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ChargeUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArgumentName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArguments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeCallbackName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_DataType.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_EnergyUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LanguageName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LengthUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LogVerbosity.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Model.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelCompute.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArguments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArgumentsCreate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelComputeArgumentsDestroy.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelCreate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelDestroy.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelDriverCreate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelRefresh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_Numbering.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SemVer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SpeciesName.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_SupportStatus.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_TemperatureUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_TimeUnit.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ComputeArgumentsImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_LogImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelImplementation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/KIM_ModelLibrary.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/old_KIM_API_DIRS.cpp
  )

target_sources(kim-api PRIVATE ${CPP_SOURCES})


add_library(kim-loader STATIC
  KIM_LogVerbosity.cpp
  KIM_Log.cpp
  KIM_LogImplementation.cpp
  old_KIM_API_DIRS.cpp
  )
target_include_directories(kim-loader PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}
  ../include
  ${CMAKE_BINARY_DIR}
  )
target_link_libraries(kim-loader ${CMAKE_DL_LIBS})

=== examples/model-drivers/CMakeLists.txt ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2018, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Richard Berger
#    Christoph Junghans
#    Ryan S. Elliott
#

#
# Release: This file is part of the kim-api.git repository.
#


cmake_minimum_required(VERSION 3.4)

add_subdirectory(ex_model_driver_P_LJ)
add_subdirectory(ex_model_driver_P_Morse)
add_subdirectory(LennardJones612__MD_414112407348_003)

=== debian/changelog ===
kim-api (2.0~beta2.gita734d1-3) unstable; urgency=medium

  * [f9aa137] Use gfortran for autopkgtests

 -- Anton Gladky <gladk@debian.org>  Sat, 09 Feb 2019 15:59:09 +0100

kim-api (2.0~beta2.gita734d1-2) unstable; urgency=medium

  * [00e2fff] Fix libexec path for the collections-management
  * [17f74c2] Use gfortran instead of fortran-compiler. (Closes: #921786)
  * [7abed38] Set Standards-Version to 4.3.0

 -- Anton Gladky <gladk@debian.org>  Sat, 09 Feb 2019 15:41:06 +0100

kim-api (2.0~beta2.gita734d1-1) unstable; urgency=medium

  * Initial packaging. (Closes: #907200)

 -- Anton Gladky <gladk@debian.org>  Fri, 24 Aug 2018 20:15:49 +0200

=== debian/control ===
Source: kim-api
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               gfortran,
               xxd
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/kim-api.git
Vcs-Git: https://salsa.debian.org/science-team/kim-api.git
Homepage: https://openkim.org

Package: libkim-api-v2-dev
Architecture: any
Section: libdevel
Depends: libkim-api-v2-2 (= ${binary:Version}),
         libkim-api-v2-fortran (= ${binary:Version}),
         libkim-api-v2-headers (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains the development files (headers and documentation) for
 KIM-API.

Package: libkim-api-v2-fortran
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Fortran files for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains the Fortran files for KIM-API.

Package: libkim-api-v2-headers
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Description: Header files for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains the headers for KIM-API.

Package: libkim-api-v2-2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Shared library for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains the shared library for KIM-API.

Package: libkim-api-v2-models
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libkim-api-v2-2 (= ${binary:Version}),
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Models and model-drivers for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains models and model-drivers for KIM-API

Package: libkim-api-v2-doc
Architecture: all
Depends: ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Documentation and examples for KIM-API
 The KIM API is an Application Programming Interface for atomistic simulations.
 The API provides a standard for exchanging information between atomistic
 simulation codes (molecular dynamics, molecular statics, lattice dynamics,
 Monte Carlo, etc.) and interatomic models (potentials or force fields).
 It also includes a set of library routines for using the API with
 bindings for:
 .
 FORTRAN 77, Fortran 90/95, Fortran 2003
 C, C++
 .
 Atomistic simulation codes that support the KIM API work seamlessly with the
 KIM-compliant interatomic models (KIM Models) distributed on this website.
 The interface is computationally efficient and often requires relatively minor
 changes to existing codes.
 .
 This package contains documentation and examples

=== debian/rules ===
#!/usr/bin/make -f

homedir = $(CURDIR)/debian/home
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export HOME = $(homedir)

%:
	dh $@

override_dh_auto_configure:
	mkdir -p $(homedir)
	dh_auto_configure -- -DKIM_API_BUILD_MODELS_AND_DRIVERS=ON

override_dh_compress:
	dh_compress -X.cpp -X.hpp -X.F90 -X.c -X.txt -X.sh

override_dh_clean:
	dh_clean
	rm -rf debian/home

=== debian/tests/control ===
Tests: cluster cluster-cpp cluster-fortran
Depends: libkim-api-v2-dev, libkim-api-v2-models, build-essential, cmake, gfortran
